; **************************
; *     By Grim_1_2_3      *
; **************************
; *    AKA(Jason Mager)    *
; **************************

; *********************
; *     Controls:     *
; *********************

; Upkey (Move forward)
; Downkey (Move backward)
; Leftkey (Turn left)
; Rightkey (Turn right)

; S key (Takes a snapshot)

AppTitle "Weaper3d Engine v1.8"

Global gfx_width = 320 
Global gfx_height = 240 
Global pp_width# = gfx_width
Global pp_height = gfx_height
Global x_offset
Global y_offset
Global center_width = pp_width / 2
Global center_height = gfx_height / 2
Global fov = 64
Global half_fov = fov / 2
Global distance_to_pp = center_width / Tan(half_fov)
Global angle_between_rays# = (fov / pp_width#)
Global slice_size
Global half_slice
Global slice_pos
Global player_x = 929
Global player_y = 391
Global pov_angle = 90
Global pov_angle2 = 270
Global player_speed
Global offset
Global ray_angle_count = 1
Global bitmap_slice
Global render_count = 0
Global wall_type = 1
Global snapshot_num = 1
Global collision_distance
Global collision_distance2
Global side1_dist
Global side2_dist
Global flag1
Global x_read
Global x_read2
Global y_read
Global f_screen_x
Global f_screen_y
Global f_world_x
Global f_world_y
Global f_tex_x
Global f_tex_y
Global floor_distance
Global floor_flag = 1
Global bleh = 1
Global final_dist
Global ry_countGlobal 
Global f_mode = 1
Global old_x
Global old_y

Global timer1
Global fps_counter = 0
Global current_fps

;Scale globals(For scaling)
Global tex_size = 64
Global scaled_tex_size
Global add_amount#
Global scale_count# = 0
Global count2 = 0

; Map array
Dim map(3599,4)

; Slice info arrays
Dim slice_tex(gfx_width)
Dim slice_po(gfx_width)
Dim slice_sc#(gfx_width)
Dim slice_add#(gfx_width)
Dim slice_wt(gfx_width)

; Cos and Sin tables
Dim cos_angle_table#(359,1024)
Dim sin_angle_table#(359,1024)

fill_cos_sin_tables()

; Fisheye table
Dim fish_table(1024,5000)

fill_fish_table()

; Half slice values table
Dim half_slice_table(5000)

h_count = 2
Repeat
half_slice_table(h_count) = (h_count / 2)
h_count = h_count + 1
Until h_count = 5001

; Add_amount table
Dim add_amount_table#(128,5000)

a_count1 = 1
a_num1# = a_count1
Repeat
a_count2 = 1
a_num2# = a_count2
Repeat
add_amount_table#(a_count1,a_count2) = (a_num1 / a_num2)
a_count2 = a_count2 + 1
a_num2# = a_count2
Until a_count2 = 5001
a_count1 = a_count1 + 1
a_num1# = a_count1
Until a_count1 = 129

Dim slice_size_table(5000)
acount = 1
Repeat
slice_size_table(acount) = (16384 / acount)
acount = acount + 1
Until acount = 5001

Dim mod_table(3840)
acount = 1
Repeat
mod_table(acount) = (acount Mod 64)
acount = acount + 1
Until acount = 3841

Dim mod_table2(10000)
acount = 0
Repeat
mod_table2(acount) = (acount Mod 2)
acount = acount + 1
Until acount = 10001

Dim distance_table(320)

Dim r_angle_table(320)

;Ray globals
Global ray_count = 0
Global start_x
Global start_y
Global ray_x
Global ray_y
Global ray_angle#
Global dx
Global dy
Global ds = 0
Global ds2 = 0
Global dist_count = 0

;Map globals
Global mapname$ = "weap1.map"
Global filein = ReadFile(mapname$)
Global file_exist = 1
Global map_pos
Global mapnum
Global start_map_pos
Global map_s1_sx
Global map_s1_sy
Global map_s1_ex
Global map_s1_ey
Global map_s2_sx
Global map_s2_sy
Global map_s2_ex
Global map_s2_ey
Global map_s3_sx
Global map_s3_sy
Global map_s3_ex
Global map_s3_ey
Global map_s4_sx
Global map_s4_sy
Global map_s4_ex
Global map_s4_ey

If file_exist = 1 Then
Repeat
load_map()
Until file_exist = 0
EndIf

Global state = 0

SetGfxDriver 1
Graphics gfx_width,gfx_height

; Image globals
Global wall1 = LoadImage("flat1_2.bmp")
Global wall2 = LoadImage("mflr8_3.bmp")
Global wall3 = LoadImage("bface.bmp")
Global wall4 = LoadImage("flat5_7.bmp")
Global wall5 = LoadImage("floor2.bmp")
Global wall6 = LoadImage("floor6_1.bmp")
Global wall7 = LoadImage("gate3.bmp")
Global wall8 = LoadImage("grnrock.bmp")

Global screen_pic = CreateImage(gfx_width,gfx_height + 128)

SetBuffer ImageBuffer(screen_pic)
DrawImage wall1,0,gfx_height
DrawImage wall2,64,gfx_height
DrawImage wall3,128,gfx_height
DrawImage wall4,192,gfx_height
DrawImage wall5,0,gfx_height + 64
DrawImage wall6,64,gfx_height + 64
DrawImage wall7,128,gfx_height + 64
DrawImage wall8,192,gfx_height + 64

SetBuffer BackBuffer()

timer1 = MilliSecs()

; Main loop
While Not state = 1
If MilliSecs() >= timer1 + 1000 Then
current_fps = fps_counter
fps_counter = 0
timer1 = MilliSecs()
EndIf
player_speed = 0
If KeyHit(1) End
Color 255,255,255
SetBuffer ImageBuffer(screen_pic)
Select f_mode
Case 2
Color 5,5,5
Rect 0,22,320,218,1
End Select
start_map_pos = player_x / 64 * 60 + player_y / 64
dist_count = 0
start_x = player_x
start_y = player_y
If flag1 = 1 Then
get_reverse_distance()
EndIf
LockBuffer 
ray_count = 0
ray_angle_count = 1
cast_rays()
update_floor3()
render_slices()
UnlockBuffer
SetBuffer BackBuffer()
CopyRect 0,0,gfx_width,gfx_height,0,0,ImageBuffer(screen_pic),BackBuffer()
Color 0,0,0
Rect 0,0,320,23,1
Rect 0,240 - 22,320,22,1
Color 5,5,5
Rect 0,22,1,196,1
Rect 319,22,1,196,1
Color 255,0,0
Text x_offset,y_offset, "FPS:" + current_fps
If collision_distance > 10 And side1_dist > 19 And side2_dist > 19 Then
If KeyDown(200) Then
player_speed = player_speed + 12
update_player_pos()
EndIf
EndIf
flag1 = 1
If collision_distance2 > 10 Then
If KeyDown(208) Then
player_speed = player_speed + 12
update_player_pos2()
EndIf
EndIf
If KeyDown(203) Then
pov_angle = pov_angle - 3
pov_angle2 = pov_angle2 - 3
If pov_angle < 0 Then pov_angle = 359
If pov_angle2 < 0 Then pov_angle2 = 359
EndIf
If KeyDown(205) Then
pov_angle = pov_angle + 3
pov_angle2 = pov_angle2 + 3
If pov_angle > 359 Then pov_angle = 0
If pov_angle2 > 359 Then pov_angle2 = 0
EndIf
If KeyHit(33) Then
Select f_mode
Case 1
f_mode = 2
Case 2
f_mode = 1
End Select
EndIf
If KeyHit(31) Then
SaveBuffer(BackBuffer(),"Weap_Sn" + (snapshot_num) + ".bmp")
snapshot_num = snapshot_num + 1
EndIf
Flip False
fps_counter = fps_counter + 1
Wend

Function fill_cos_sin_tables()
cos_count = 0
Repeat
cos_count2 = 1
r_angle# = 328
Repeat
cos_angle_table#(cos_count,cos_count2) = Cos(r_angle + cos_count)
cos_count2 = cos_count2 + 1
r_angle# = r_angle# + angle_between_rays
Until cos_count2 = pp_width + 1
cos_count = cos_count + 1
Until cos_count = 360
sin_count = 0
Repeat
sin_count2 = 1
r_angle# = 328
Repeat
sin_angle_table#(sin_count,sin_count2) = Sin(r_angle + sin_count)
sin_count2 = sin_count2 + 1
r_angle# = r_angle# + angle_between_rays
Until sin_count2 = pp_width + 1
sin_count = sin_count + 1
Until sin_count = 360
End Function

Function fill_fish_table()
f_count1 = 1
f_angle# = 328
Repeat
f_count2 = 1
Repeat
fish_table(f_count1,f_count2) = (Cos(f_angle)*f_count2)
f_count2 = f_count2  + 1
Until f_count2 = 5001
f_angle = f_angle + angle_between_rays
f_count1 = f_count1 + 1
Until f_count1 = pp_width + 1
End Function

Function load_map()
If Not Eof( filein )
mapnum = ReadInt( filein )
map(mapnum,2) = ReadInt( filein )
map(mapnum,3) = ReadInt( filein )
map(mapnum,4) = ReadInt( filein )
map(mapnum,1) = 1
Else
If Eof( filein ) Then
CloseFile( filein )
file_exist = 0
EndIf
EndIf
End Function

Function re_init_main_variables()
center_width = pp_width / 2
fov = 64
half_fov = fov / 2
distance_to_pp = center_width / Tan(half_fov)
angle_between_rays# = (fov / pp_width#)
End Function

Function cast_rays()
ray_angle = 328
Repeat
start_x = player_x
start_y = player_y
dist_count = 0
start_map_pos = player_x / 64 * 60 + player_y / 64
get_first_intersection()
ray_angle = ray_angle + angle_between_rays
ray_angle_count = ray_angle_count + 1
ray_count = ray_count + 1
Until ray_count = pp_width
End Function

Function get_reverse_distance()
Repeat
ray_x = start_x + dist_count*Cos(pov_angle2)
ray_y = start_y + dist_count*Sin(pov_angle2)
map_pos = ray_x / 64 * 60 + ray_y / 64
If Not map_pos = start_map_pos Then
ms = 1
Else
If map_pos = start_map_pos Then
ms = 2
dist_count = dist_count + 1
EndIf
EndIf
Until ms = 1
check_reverse_for_wall()
End Function

Function check_reverse_for_wall()
If map(map_pos,1) = 1 Then
dx = Abs (ray_x-start_x)
dy = Abs (ray_y-start_y)
ds = Sqr((dx*dx) + (dy*dy))
ds = Cos(ray_angle)*ds
collision_distance2 = ds
Else
start_map_pos = map_pos
get_reverse_distance()
EndIf
End Function

Function get_first_intersection()
Repeat
ray_x = start_x + dist_count*cos_angle_table#(pov_angle,ray_angle_count)
ray_y = start_y + dist_count*sin_angle_table#(pov_angle,ray_angle_count)
map_pos = ray_x / 64 * 60 + ray_y / 64
If Not map_pos = start_map_pos Then
ms = 1
Else
If map_pos = start_map_pos Then
ms = 2
dist_count = dist_count + 1
EndIf
EndIf
Until ms = 1
check_first_intersection()
End Function

Function check_first_intersection()
If map(map_pos,1) = 1 Then
dx = Abs (ray_x-start_x)
dy = Abs (ray_y-start_y)
ds = Sqr((dx*dx) + (dy*dy))
ds = fish_table(ray_angle_count,ds) ;+ Cos(ray_angle)
distance_table(ray_count) = dist_count
r_angle_table(ray_count) = ray_angle_count
If ray_count = pp_width / 2 Then
collision_distance = ds
EndIf
If ray_count = 0 Then
side1_dist = ds
EndIf
If ray_count = pp_width - 1 Then
side2_dist = ds
EndIf
get_vector_positions()
get_texture_offset()
update_plain_slice()
Else
start_map_pos = map_pos
get_first_intersection()
EndIf
End Function

Function get_vector_positions()
x = map(map_pos,3)
y = map(map_pos,4)
map_s1_sx = x
map_s1_sy = y
map_s1_ex = x + 63
map_s1_ey = y
map_s2_sx = map_s1_ex
map_s2_sy = y
map_s2_ex = map_s2_sx
map_s2_ey = y + 63
map_s3_sx = map_s2_ex
map_s3_sy = map_s2_ey
map_s3_ex = map_s3_sx - 63
map_s3_ey = map_s3_sy
map_s4_sx = map_s3_ex
map_s4_sy = map_s3_ey
map_s4_ex = map_s4_sx
map_s4_ey = map_s4_sy - 63
End Function

Function get_texture_offset()
If ray_x > map_s1_sx And ray_x < map_s1_ex And ray_y = map_s1_sy Then
vx = Abs (map_s1_sx-ray_x)
vy = Abs (map_s1_sy-ray_y)
vs = Sqr((vx*vx) + (vy*vy))
offset = 64 - vs
EndIf
If ray_x = map_s2_sx And ray_y > map_s2_sy And ray_y < map_s2_ey Then
vx = Abs (map_s2_sx-ray_x)
vy = Abs (map_s2_sy-ray_y)
vs = Sqr((vx*vx) + (vy*vy))
offset = 64 - vs
EndIf
If ray_x > map_s3_ex And ray_x < map_s3_sx And ray_y = map_s3_sy Then
vx = Abs (map_s3_sx-ray_x)
vy = Abs (map_s3_sy-ray_y)
vs = Sqr((vx*vx) + (vy*vy))
offset = 64 - vs
EndIf
If ray_x = map_s4_sx And ray_y > map_s4_ey And ray_y < map_s4_sy Then
vx = Abs (map_s4_sx-ray_x)
vy = Abs (map_s4_sy-ray_y)
vs = Sqr((vx*vx) + (vy*vy))
offset = 64 - vs
EndIf
If ray_x = map_s1_sx And ray_y = map_s1_sy Then offset = 64
If ray_x = map_s1_ex And ray_y = map_s1_ey Then offset = 1
If ray_x = map_s3_ex And ray_y = map_s3_ey Then offset = 1
If ray_x = map_s3_sx And ray_y = map_s3_sy Then offset = 64
offset = offset - 1
wall_type = map(map_pos,2)
bitmap_slice = offset
slice_tex(ray_count) = bitmap_slice
If slice_tex(ray_count) < 0 Then
slice_tex(ray_count) = 0
EndIf
If slice_tex(ray_count) > 63 Then
slice_tex(ray_count) = 63
EndIf
slice_wt(ray_count) = wall_type
End Function

Function update_plain_slice()
slice_size = (64 * distance_to_pp) / ds
slice_sc(ray_count) = slice_size
half_slice = half_slice_table(slice_size)
slice_pos = center_height - half_slice
slice_po(ray_count) = slice_pos
add_amount = add_amount_table#(tex_size,slice_size)
slice_add(ray_count) = add_amount
End Function

Function update_floor3()
ry_count = 1
Repeat
ray_angle_count2 = r_angle_table(ry_count)
dist_count2 = 0
Repeat
f_world_x = start_x + dist_count2*cos_angle_table#(pov_angle,ray_angle_count2)
f_world_y = start_y + dist_count2*sin_angle_table#(pov_angle,ray_angle_count2)
floor_distance = dist_count2
floor_distance = fish_table(ray_angle_count2,floor_distance) ;+ Cos(ray_angle)
f_screen_x = (x_offset + ry_count)
f_tex_x = mod_table(f_world_x)
f_tex_x = f_tex_x - 1
If f_tex_x < 0 Then f_tex_x = 0
If f_tex_x > 63 Then f_tex_x = 63
f_tex_y = mod_table(f_world_y)
f_tex_y = f_tex_y - 1
If f_tex_y < 0 Then f_tex_y = 0
If f_tex_y > 63 Then f_tex_y = 63
If floor_distance > 0 Then
f_size = slice_size_table(floor_distance)
hf = mod_table2(f_size)
f_size = f_size - hf
half_f_slice = f_size / 2 
f_screen_y = (center_height + half_f_slice) - 1
f_screen_y2 = (center_height - half_f_slice) + 1
check_wall_type2()
If Not f_screen_y = old_y Then
If f_screen_y > y_offset -1 And f_screen_y < (y_offset + pp_height - 22) Then 
WritePixelFast f_screen_x,f_screen_y,ReadPixelFast(x_read,y_read)
Select f_mode
Case 1
WritePixelFast f_screen_x + 1,f_screen_y,ReadPixelFast(x_read,y_read)
End Select
If f_screen_y2 > y_offset + 22 And f_screen_y2 < (y_offset + pp_height - 22) Then
WritePixelFast f_screen_x,f_screen_y2,ReadPixelFast(x_read2,y_read)
Select f_mode
Case 1
WritePixelFast f_screen_x + 1,f_screen_y2,ReadPixelFast(x_read2,y_read)
End Select
EndIf
EndIf
EndIf
EndIf
old_x = f_screen_x
old_y = f_screen_y 
dist_count2 = dist_count2 + 1
Until dist_count2 = distance_table(ry_count)
ry_count = ry_count + 2
Until ry_count = pp_width + 1
End Function

Function render_slices()
Repeat
scaled_tex_size = slice_sc(render_count)
slice_pos = slice_po(render_count)
add_amount = slice_add(render_count)
check_wall_type()
scale_slice_fast()
render_count = render_count + 1
Until render_count = pp_width
render_count = 0
End Function

Function check_wall_type()
Select slice_wt(render_count)
Case 1
x_read = 0 + slice_tex(render_count)
y_read = gfx_height 
Case 2
x_read = 64 + slice_tex(render_count)
y_read = gfx_height 
Case 3
x_read = 128 + slice_tex(render_count)
y_read = gfx_height 
Case 4
x_read = 192 + slice_tex(render_count)
y_read = gfx_height 
Case 5
x_read = 0 + slice_tex(render_count)
y_read = gfx_height + 64
Case 6
x_read = 64 + slice_tex(render_count)
y_read = gfx_height + 64
Case 7
x_read = 128 + slice_tex(render_count)
y_read = gfx_height + 64
Case 8
x_read = 192 + slice_tex(render_count)
y_read = gfx_height + 64
End Select
End Function

Function check_wall_type2()
x_read = 192 + f_tex_x 
x_read2 = 128 + f_tex_x
y_read = f_tex_y
y_read = y_read + (gfx_height + 64)
End Function

Function scale_slice_fast()
Repeat
If (slice_pos + count2) > 22 And (slice_pos + count2) < (218) Then
WritePixelFast render_count,(slice_pos + count2),ReadPixelFast(x_read,y_read + scale_count)
EndIf
scale_count = scale_count + add_amount
count2 = count2 + 1
Until count2 = (scaled_tex_size - 1)
scale_count = 0
count2 = 0
End Function

Function update_player_pos()
player_x = player_x + Cos(pov_angle)*player_speed
player_y = player_y + Sin(pov_angle)*player_speed
End Function

Function update_player_pos2()
player_x = player_x + Cos(pov_angle2)*player_speed
player_y = player_y + Sin(pov_angle2)*player_speed
End Function